// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
//  AppDelegate.m
//  Created by djzero00 - - Copyright (c) 2002
//
// realizzazione della classe delegata di applicazione

#import "AppDelegate.h"

#import	"InfoWinCtrl.h"
#import	"FindWinCtrl.h"
#import	"PrefWinCtrl.h"
#import	"AboutWinCtrl.h"

@implementation AppDelegate

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
- (IBAction)showInfoPanel:(id)sender
{
	// mostro la finestra invocando l'istanza condivisa
	[ [ InfoWinCtrl sharedInfoWinCtrl ] showWindow: sender ] ;
}


// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
- (IBAction) showPalette: (id)sender
{
	[ [FindWinCtrl sharedFind] showWindow: sender] ;	
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
- (IBAction) showPrefsWin: (id)sender
{
	[ [PrefWinCtrl sharedPrefsCtrl] showWindow: sender] ;	
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
- (IBAction)showAboutBox:(id)sender
{
	// questa volta, invece di fare le solite cose, mi chiedo se l'utente ha
	// tenuto premuto il taso ALT (altrimenti noto come Option), per mostrare
	// la finestra normale oppure la nuova finestra come "Easter Egg"
	
	// recupero l'evento corrente, controllo lo stato della tastiera
	// e verifico se il tasto Alt  premuto
	if ([[NSApp currentEvent] modifierFlags] & NSAlternateKeyMask)
	{
		// la risposta e' si', procedo alla visualizzazione della nuova finestra
		// uso la solita tecnica
		[ [AboutWinCtrl sharedAboutWinCtrl] showWindow: sender] ;	
	}
	else
	{
		// nessun tasto premuto, faccio vedere le solite cose
		[ NSApp	orderFrontStandardAboutPanel: self ];
	}
}
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

@end
