// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
//  CatalogDoc.h
//  Created by djzero00 -- Copyright (c) 2002
//
// Interfaccia della classe Documento di Catalogo

#import <Cocoa/Cocoa.h>

#import		"LSDataSource.h"

@interface CatalogDoc : NSDocument
{
	// dati presenti nel file
	NSData			* dataFromFile ;
	// sorgente di dati per la finestra
	LSDataSource 		* dataSource;
	// outlet alla Outline
	IBOutlet NSOutlineView	* outlineView ;
}
// per caricare la finestra dal nib
- (NSString *)windowNibName ;
- (void)windowControllerDidLoadNib:(NSWindowController *) aController ;

- (NSData *)dataRepresentationOfType:(NSString *)aType ;
- (BOOL)loadDataRepresentation:(NSData *)data ofType:(NSString *)aType ;

// per caricare i dati da un file
- (void) loadCatalogWithData: (NSData *) data ;
// aggiunta di un elemento al catalogo
- (void) addFileItem: (id)sender ;
// rimozione di un elemento dal catalogo
- (void) delItem: (id)sender ;
// distruzione del catalogo
- (void) dealloc ;

#if	ADD_ONLY_VOLUMES
// aggiunta di un volume in risposta al dialogo
- (void) addVolume2Cat: (NSWindow *)sheet returnCode: (int)returnCode contextInfo: (void  *)contextInfo ;
#endif

- (void) performAddFilesModal: (NSArray *)volList ;

// metodi accessor
- (NSData *) dataFromFile ;
- (LSDataSource *)  dataSource ;
- (void) setDataFromFile: ( NSData*) data ;
- (void) setDataSource: (LSDataSource*) ds ;
- (NSOutlineView * ) outlineView ;

// metodi per la gestione del drag'n'drop
- (unsigned int)draggingEntered:(id<NSDraggingInfo>)sender ;
- (unsigned int)draggingUpdated:(id<NSDraggingInfo>)sender ;
- (IBAction)draggingExited:(id<NSDraggingInfo>)sender ;
- (BOOL)prepareForDragOperation:(id<NSDraggingInfo>)sender ;
- (BOOL)performDragOperation:(id<NSDraggingInfo>)sender ;
- (IBAction)concludeDragOperation:(id<NSDraggingInfo>)sender ;

// metodi per la gestione della toolbar
- (void)  addToolbarToWin: (NSWindow *) currWin ;
- (NSToolbarItem *) toolbar: (NSToolbar *)t itemForItemIdentifier: (NSString *) i willBeInsertedIntoToolbar:(BOOL) w ;
- (NSArray *) toolbarDefaultItemIdentifiers: (NSToolbar *) toolbar ;
- (NSArray *) toolbarAllowedItemIdentifiers: (NSToolbar *) toolbar ;
- (void) toolbarWillAddItem: (NSNotification *) notif ;
- (BOOL) validateToolbarItem: (NSToolbarItem *) toolbarItem ;

- (void) changeSortOrder: (id) sender ;
- (BOOL)outlineView: (NSOutlineView *) oView shouldEditTableColumn: (NSTableColumn *) tableColumn item:(id) item ;

- (BOOL)outlineView: (NSOutlineView *) oView shouldSelectTableColumn:(NSTableColumn *)tableColumn;


// per il momento non esiste
- (void)	changeFont: (id) sender ;
@end
