// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
//  LSDataSource.h
//  Created by djzero00 -- Copyright (c) 2002
//
// Interfaccia della classe sorgente di dati con un catalogo di file

#import <Cocoa/Cocoa.h>

#import 	"FileStruct.h"

// la sorgente dei dati e' una tabella; nelle righe ci sono i vari
// file, nelle colonne i diversi attributi del file

@interface LSDataSource : NSObject
{
	// ho solo bisogno di un elenco di file
	NSMutableArray	*startPoint ;
	
	// criterio di ordine
	NSString	* orderColumn ;
	// direzione
	BOOL		orderDirection ;
}
// inizializzazione e disallocazione
- (id) init ;
- (void) dealloc ;

// metodi accessor
- (NSMutableArray*)startPoint;
- (void)setStartPoint:(NSMutableArray*)newStartPoint;
- (NSString*)orderColumn;
- (void)setOrderColumn:(NSString*)newStartPoint;
- (BOOL)orderDirection;
- (void)setOrderDirection:(BOOL)newStartPoint;

// metodo per inserire un file al catalogo
- (void) addFileEntry: (id) newEntry ;

// funzioni necessarie al trattamento della NSOutlineView
- (int)	outlineView: (NSOutlineView *) outlineView numberOfChildrenOfItem: (id) item;
- (BOOL)outlineView: (NSOutlineView *) outlineView isItemExpandable: (id) item ;
- (id)	outlineView: (NSOutlineView *) outlineView child: (int) index ofItem: (id) item ;
- (id)	outlineView: (NSOutlineView *) outlineView objectValueForTableColumn: (NSTableColumn *) tableColumn byItem: (id) item;

- (void) searchFor: (id) item2search column: (NSString*) colId options: (int) opt placeIn: (NSMutableArray*) foundItems ;

- (void) expandDStoItem: (FileStruct*) item inOutlineView: (NSOutlineView *) outView ;

@end
