// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
//  lsFileInfo.h
//  Created by djzero00 on Tue Nov 27 2001.
//  Copyright (c) 2001 __MyCompanyName__. All rights reserved.
//
// Interfaccia della classe che modella le informazioni relative ad un file

#import <Cocoa/Cocoa.h>

// nomi delle colonne dei dati
#define		COLID_FILENAME		@"fileName"
#define		COLID_FULLPATH		@"fileFullPath"
#define		COLID_MODDATE		@"modDate"
#define		COLID_FILESIZE		@"fileSize"
#define		COLID_GROUPNAME		@"ownGroupName"
#define		COLID_OWNERNAME		@"ownerName"
#define		COLID_POSIXPERM		@"filePosixPerm"
#define		COLID_FILETYPE		@"fileType"
#define		COLID_OSCREATOR		@"creatorCode"
#define		COLID_OSTYPE		@"typeCode"
#define		COLID_FSFILENUM		@"fsFileNum"
#define		COLID_FSNUM		@"fsNum"

@interface LSFileInfo : NSObject {
	// nome completo di path del file
	NSString  	*fileFullPath ;
	// il solo nome del file, pronto per tutti gli usi
	NSString  	*fileName ;
	// data di ultima modifica del file
	NSDate 		*modDate ;	// NSFileModificationDate
	// dimensione in byte del file
	unsigned long long	fileSize;	// NSFileSize
	// nome del gruppo di utenti proprietari del file
	NSString 	*ownGroupName ;	// NSFileGroupOwnerAccountName
	// utente proprietario del file
	NSString 	*ownerName ;	// NSFileOwnerAccountName
	// permessi di accesso secondo lo standard Posix
	unsigned long	filePosixPerm ;	// NSFilePosixPermissions
	// tipo di file (normale, directory, eccetera)
	NSString 	*fileType ;	// NSFileType
	// codice CREATOR come in MacOS9
	OSType		creatorCode ;	// NSFileHFSCreatorCode
	// codice TYPE come in MacOS9
	OSType		typeCode ;	// NSFileHFSTypeCode
	// numero di hard link che si riferiscono al file
        long		refCount ;	// NSFileReferenceCount
	// chi lo sa
        unsigned long	fsFileNum ;	// NSFileSystemFileNumber
	// chi lo sa
        unsigned long	fsNum ;	 	// NSFileSystemNumber
	// estensione visualizzata o meno
        BOOL		extHidden ;	// NSFileExtensionHidden
	// icona del file
	NSImage		* fileIcon ;
    }

// inizializzazione dell'istanza in base al nome completo
- (id) initWithPath: (NSString*) fullPath ;
- (void) dealloc ;

// metodi per il salvataggio/recupero su file
- (void)encodeWithCoder:(NSCoder *)encoder ;
- (id)initWithCoder:(NSCoder *)decoder ;

// metodi "accessor"
- (NSString*)fileFullPath;
- (void)setFileFullPath:(NSString*)newFileFullPath;

- (NSString*)fileName;
- (void)setFileName:(NSString*)newFileName;

- (NSDate*)modDate;
- (void)setModDate:(NSDate*)newModDate;

- (unsigned long long)fileSize;
- (void)setFileSize:(unsigned long long)newFileSize;

- (NSString*)ownGroupName;
- (void)setOwnGroupName:(NSString*)newFgoan;

- (NSString*)ownerName;
- (void)setOwnerName:(NSString*)newFoan;

- (unsigned long)filePosixPerm;
- (void)setFilePosixPerm:(unsigned long)newFilePosixPerm;

- (NSString*)fileType;
- (void)setFileType:(NSString*)newFileType;

- (OSType)creatorCode;
- (void)setCreatorCode:(OSType)newCreatorCode;

- (OSType)typeCode;
- (void)setTypeCode:(OSType)newTypeCode;

- (long)refCount;
- (void)setRefCount:(long)newrefCount;

- (unsigned long)fsFileNum;
- (void)setFsFileNum:(unsigned long)newfsFileNum;

- (unsigned long)fsNum;
- (void)setFsNum:(unsigned long)newfsNum;

- (BOOL)extHidden;
- (void)setExtHidden:(BOOL)newExtHidden;

- (NSImage *)fileIcon;
- (void)setFileIcon:(NSImage *)newicon;

@end
