// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
//  UserPrefs.h
//  Created by djzero00 -- Copyright (c) 2002
//
// Interfaccia della classe per la gestione delle preference

#import <Cocoa/Cocoa.h>

// notifica di aggiornamento rpeferenze
#define		PREF_UPDATE_NOTIFICATION	@"PrefsUpdateNotification"

// chiavi nel dizionario delle preferenze
#define 	keyExpandBundle 	@"ExpandBundle"
#define 	keyShowDotFiles		@"ShowDotFiles"
#define 	keyColFullPath		@"ColFullPath"
#define 	keyColModDate		@"ColModDate"
#define 	keyColFileSize		@"ColFileSize"
#define 	keyColGroupName		@"ColGroupName"
#define 	keyColOwnerName		@"ColOwnerName"
#define 	keyColPosixPerm		@"ColPosixPerm"
#define 	keyColFileType		@"ColFileType"
#define 	keyColCreator		@"ColCreator"
#define 	keyColOSType		@"ColOSType"
#define 	keyColFsFileNum		@"ColFsFileNum"
#define 	keyColFsNum		@"ColFsNum"

@interface UserPrefs : NSObject {
	// valori correnti delle preferenze
	NSMutableDictionary 		*defCurrValues;
}
// metodi (fintamente) di classe per la gestione
// recupero di un valore di una preferenza
+ ( id ) getPrefValue: (id) key ;
// per avere l'intero dizionario delle preferenze
+ ( NSMutableDictionary*) getPrefs ;
// per caricare i default dal file
+ (void) loadPrefsFromDefault ;
// per salvare i default su file
+ (void) savePrefsToDefault: ( NSMutableDictionary*) newPref ;

// metodi interni di utilita'
// inizializzazione della classe/istanza
- ( id ) init ;
// metodi accessor
- ( NSMutableDictionary*) defCurrValues ;
- (void) setDefCurrValues: ( NSMutableDictionary*) newPref ;
	
@end
