// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
//  LSFormatter.m
//  Created by djzero00 - - Copyright (c) 2002
//
// realizzazione delle classi formattatori

#import "LSFormatter.h"

#import		"djZeroUtils.h"

// --------------------------------------------------------------------- 
@implementation TOS9TCForm

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
// per convertire un OSType -- creatore e tipo di MacOS9 - in stringa
// (long che contiene in realta' quattro char)

- (NSString *)
stringForObjectValue:	(id)anObject
{

#if	!( TYPECREAT_APPLE_DOC )
	// per convertire un long in quattro char, uso una union
	union {
		long  typeLong ;
		char  typeChar[4];
	}	cvtLongchar ;
	// stringa C destinazione
	char	destCString[6] ;
#endif
	// controllo che l'oggetto sia un numero...
	if (![anObject isKindOfClass:[NSNumber class]]) {
		return nil;
	}
#if	TYPECREAT_APPLE_DOC
	// la documentazione Apple afferma che e' meglio usare la funzione
	// sotto indicata piuttosto che fare da soli...
	return ( NSFileTypeForHFSTypeCode( [ anObject longValue ]) );
	// anche se penso sia difficile far meglio del codice seguente...
#else
	// metto il long dentro la union
	cvtLongchar.typeLong = [ anObject longValue ] ;
	// lo riscrivo come stringa
	destCString[0] = cvtLongchar.typeChar[0] ;
	destCString[1] = cvtLongchar.typeChar[1] ;
	destCString[2] = cvtLongchar.typeChar[2] ;
	destCString[3] = cvtLongchar.typeChar[3] ;
	// chiudo la stringa
	destCString[4] = 0 ;
	// converto la stringa C in NSString e la restituisco
	return ( [ NSString stringWithCString: destCString ] );
#endif
}
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
// al momento queste due funzioni ci devono essere ma non servono
- (BOOL)
getObjectValue:			(id *)anObject 
	forString:		(NSString *)string 
	errorDescription:	(NSString **)error
{
	return ( YES );
}

- (NSAttributedString *)
attributedStringForObjectValue:	(id)anObject 
	withDefaultAttributes:	(NSDictionary *)attributes
{
	return ( nil);
}
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
@end

// --------------------------------------------------------------------- 
@implementation FileSizeForm

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
// funzione per convertire un numero long, che rappresenta una dimensione
// in byte, in qualcosa di piu' gradevole
// se dim < 1K, scrivo byte; se dim < 1Mega, scrivo K; eccetera

- (NSString *)
stringForObjectValue:	(id)anObject
{
	unsigned long long	fSize, fSizeK ;
	float 			fsizeM, fsizeG ;
	
	// controllo che l'oggetto sia un numero...
	if (![anObject isKindOfClass:[NSNumber class]]) {
		return nil;
	}
	// ricavo la dimensione del file
	fSize = [ ((NSNumber*) anObject) longLongValue ];
	// se il file e' piccolo, mostro byte
	if ( fSize < 1024 )
	{
		long	tmp = fSize ;
		return ( [ NSString stringWithFormat: @" %4d b", tmp] );
	}
	// la dimensione e' in byte, divido per 1024 ed arrotondo, ottengo K
	fSizeK = (long) (( fSize / 1024.0 ) + 0.5 );
	// se il file e' medio, mostro K
	if ( fSizeK < 1024 )
	{
		long	tmp = fSizeK ;
		return ( [ NSString stringWithFormat: @" %4d K", tmp] );
	}
	// se inferiore al giga, restituisco mega con tre decimali
	fsizeM = ( fSizeK / 1024.0 ) ;
	if ( fsizeM < 1024 )
		return ( [ NSString stringWithFormat: @" %6.3f M", fsizeM] );
	// negli altri casi, ritorno Giga, con tre cifre decimali
	fsizeG = ( fsizeM / 1024.0 ) ;
	return ( [ NSString stringWithFormat: @" %6.3f G", fsizeG] );
}
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
// al momento queste due funzioni ci devono essere ma non servono
- (BOOL)
getObjectValue:			(id *)anObject 
	forString:		(NSString *)string 
	errorDescription:	(NSString **)error
{
	return ( YES );
}

- (NSAttributedString *)
attributedStringForObjectValue:	(id)anObject 
	withDefaultAttributes:	(NSDictionary *)attributes
{
	return ( nil);
}
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
@end

// --------------------------------------------------------------------- 
@implementation FilePosixPerm

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
// per rappresentare i permessi posix di lettura/scrittura
// devo convertire un numero long nei permessi posix:

- (NSString *)
stringForObjectValue:	(id)anObject
{
	char		permstring[10] ;
	unsigned long 	perm ;
	
	// controllo che l'oggetto sia un numero...
	if (![anObject isKindOfClass:[NSNumber class]]) {
		return nil;
	}
	// ricavo il long che mi da i permessi
	perm = [ anObject longValue ] ;
	// e poi e' tutto un sottile gioco di bit
	permstring[0] = ( perm & 0x0100 ) ? 'r' : '-' ;
	permstring[1] = ( perm & 0x0080 ) ? 'w' : '-' ;
	permstring[2] = ( perm & 0x0040 ) ? 'x' : '-' ;
	permstring[3] = ( perm & 0x0020 ) ? 'r' : '-' ;
	permstring[4] = ( perm & 0x0010 ) ? 'w' : '-' ;
	permstring[5] = ( perm & 0x0008 ) ? 'x' : '-' ;
	permstring[6] = ( perm & 0x0004 ) ? 'r' : '-' ;
	permstring[7] = ( perm & 0x0002 ) ? 'w' : '-' ;
	permstring[8] = ( perm & 0x0001 ) ? 'x' : '-' ;
	// chiudo la stringa C
	permstring[9] = 0 ;
	// converto la stringa C in NSString e la restituisco
	return ( [ NSString stringWithCString: permstring ] );
}
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
// al momento queste due funzioni ci devono essere ma non servono
- (BOOL)
getObjectValue:			(id *)anObject 
	forString:		(NSString *)string 
	errorDescription:	(NSString **)error
{
	return ( YES );
}

- (NSAttributedString *)
attributedStringForObjectValue:	(id)anObject 
	withDefaultAttributes:	(NSDictionary *)attributes
{
	return ( nil);
}
// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
@end
