// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
//  FindWinCtrl.h
//  Created by djzero00 -- Copyright (c) 2002
//
// Finestra per effettuare ricerche in un catalogo

#import <Cocoa/Cocoa.h>

#import	"CatalogDoc.h"

// menu del campo di ricerca "where"
#define		MENUTAG_FILENAME		 0
#define		MENUTAG_FULLPATH		 1
#define		MENUTAG_MODDATE			 2
#define		MENUTAG_FILESIZE		 3
#define		MENUTAG_GROUPNAME		 4
#define		MENUTAG_OWNERNAME		 5
#define		MENUTAG_POSIXPERM		 6
#define		MENUTAG_FILETYPE		 7
#define		MENUTAG_OSCREATOR		 8
#define		MENUTAG_OSTYPE			 9
#define		MENUTAG_FSFILENUM		10
#define		MENUTAG_FSNUM			11

// menu delle opzioni di ricerca stringa
#define		MENUTAG_STR_ISCONTIANED		101
#define		MENUTAG_STR_ISEQUAL		102

// menu delle opzioni di ricerca numerica
#define		MENUTAG_NUM_GREAT		201
#define		MENUTAG_NUM_GREATEQ		202
#define		MENUTAG_NUM_EQ			203
#define		MENUTAG_NUM_LESSEQ		204
#define		MENUTAG_NUM_LESS		205

@interface FindWinCtrl : NSWindowController
{
	IBOutlet NSTextField 	* FindText;
	IBOutlet NSPopUpButton 	* howOpt;
	IBOutlet NSTableView 	* resultFld;
	IBOutlet NSPopUpButton 	* whereOpt;
	IBOutlet NSMenu 	* stringMenu;
	IBOutlet NSMenu 	* numberMenu;

	// documento cui si riferisce la ricerca
	CatalogDoc	* currCatalog ;
	// vettore con i risultati
	NSMutableArray 	* foundItems;
}
// per cominciare la ricerca
- (IBAction)startSearch: (id)sender;
// cambiamento del menu a seconda del tipo di campo
- (IBAction)changeCfrMenu: (id)sender;
// per evidenziare l'elemento selezionato
- (IBAction)goToItem: (id)sender;

+ (id) sharedFind ;

- (int) numberOfRowsInTableView:(NSTableView *)tv;
- (id) tableView:(NSTableView *)tv objectValueForTableColumn:(NSTableColumn *)tc row:(int)row;
- (BOOL) tableView:(NSTableView *)tv shouldEditTableColumn:(NSTableColumn *)tc row:(int)row ;

- (CatalogDoc *)currCatalog ;
- (void)setCurrCatalog :(CatalogDoc *)newCurrCatalog ;
- (NSMutableArray *)foundItems;
- (void)setFoundItems:(NSMutableArray *)newFoundItems;

@end
