// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
//  InfoWinCtrl.h
//  Created by djzero00 -- Copyright (c) 2002
//
// Interfaccia della classe per la gestione delle info sul file

#import <Cocoa/Cocoa.h>

#import "CatalogDoc.h"
#import "FileStruct.h"

#define		USER_SELECT_ROW 	@"UserSelectRow"

@interface InfoWinCtrl : NSWindowController
{
	// tutti questi outlet, costruiti da IB, per accedere
	// ai vari elementi dell'interfaccia: corrispondono piu' 
	// o meno alle variabili di LSFileInfo
	IBOutlet NSTextField *fileSize;
	IBOutlet NSTextField *fileType;
	IBOutlet NSTextField *fsFileNum;
	IBOutlet NSTextField *fsNum;
	IBOutlet NSTextField *fullPath;
	IBOutlet NSTextField *groupName;
	IBOutlet NSTextField *modDate;
	IBOutlet NSTextField *osCreator;
	IBOutlet NSTextField *osType;
	IBOutlet NSTextField *ownerName;
	IBOutlet NSTextField *posixPerm;
	IBOutlet NSImageView *fileIcon;
}
// per accedere all'istanza condivisa
+ ( id )	sharedInfoWinCtrl ;
// inizializzazione e deallocazione
- ( id )	init ;
- (void)	windowDidLoad ;
- (void)	dealloc ;
// per rispondere alle selezioni
- (void)	selectionChanged: ( NSNotification *) notification ;
- (void)	updateInfo: (NSOutlineView *) locItem ;

@end
