// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
//  PrefWinCtrl.m
//  Created by djzero00 - - Copyright (c) 2002
//
// realizzazione della classe per la gestione delle preference

#import 	"PrefWinCtrl.h"

#import 	"UserPrefs.h"
#import		"djZeroUtils.h"

// variabili di comodo per evitare calcoli
static NSNumber *lsPrefsYes = nil;
static NSNumber *lsPrefsNo = nil;

@implementation PrefWinCtrl

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
+ ( id ) 
sharedPrefsCtrl 
{
	// variabile statica del controllore della unica finestra
	static	PrefWinCtrl	* locSharedWinCtrl  = nil ;
	// se ce l'ho gia', faccio nulla
	if ( ! locSharedWinCtrl )
	{	
		// altrimenti, genero l'istanza
		locSharedWinCtrl = [[ PrefWinCtrl allocWithZone: [self zone]] init ] ;
		// inizializzo queste due variabili che mi servono poi
		lsPrefsYes = [[NSNumber alloc] initWithBool:YES];
		lsPrefsNo = [[NSNumber alloc] initWithBool:NO];
	}
	// restituisco l'istanza condivisa
	return ( locSharedWinCtrl );
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
- (id )
init 
{
	// carico la finestra dal nib
	self = [ self initWithWindowNibName: @"prefsPane" ];
	if ( self )
	{
		// salvo nelle prefs la posizione della finestra delle prefs
		[ self setWindowFrameAutosaveName: @"Preferences" ];
		// assegno gli stessi valori anche a def-disp
		[self setDefDispValues: [ UserPrefs getPrefs ] ];
	}
	return ( self );
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
// preparo la finestra la suo lavoro
- (void)
windowDidLoad 
{
	[ super windowDidLoad ] ;
	// non voglio che compaia nella lista delle finestre
	[[self window] setExcludedFromWindowsMenu:YES];
	// non ci sono menu particolari associati alla view
	[[self window] setMenu:nil];
	// aggiorno l'aseptto della finestra
	[self updatePrefWindow];
	// la piazzo al centro dello schermo
	[[self window] center];
	// porto la finestra davanti a tutti
	[[self window] makeKeyAndOrderFront:nil];
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
- (void)
updatePrefWindow 
{

#define		MATRIX_SET_STATE( key, row, col)		\
	[colDspMatrix setState: ([ [defDispValues objectForKey: key] boolValue] ? 1 : 0) atRow: row column: col ]

	// recupero il valore, ed imposto il bottone di conseguenza
	[expandBundleButton setState:[[defDispValues objectForKey:keyExpandBundle] boolValue] ? 1 : 0];
	[showDotFilesButton setState:[ [defDispValues objectForKey: keyShowDotFiles] boolValue] ? 1 : 0 ] ;
	// metto a posto i vari elementi dell'interfaccia
	MATRIX_SET_STATE( keyColModDate, 	0, 0 );
	MATRIX_SET_STATE( keyColFileSize, 	1, 0 );
	MATRIX_SET_STATE( keyColGroupName, 	2, 0 );
	MATRIX_SET_STATE( keyColOwnerName, 	3, 0 );
	MATRIX_SET_STATE( keyColPosixPerm, 	4, 0 );
	MATRIX_SET_STATE( keyColFileType, 	5, 0 );
	MATRIX_SET_STATE( keyColFullPath, 	0, 1 );
	MATRIX_SET_STATE( keyColOSType, 	1, 1 );
	MATRIX_SET_STATE( keyColCreator, 	2, 1 );
	MATRIX_SET_STATE( keyColFsFileNum, 	3, 1 );
	MATRIX_SET_STATE( keyColFsNum, 		4, 1 );
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
// la finestra delle preference ha tre pulsanti:
// con OK, caso (a), imposto def-disp su def-curr, poi chiudo la finestra
// con Restore, caso (b), imposto def-disp con def-curr; aggiorno e lascio aperta la finestra
// con Cancel, caso (c), chiudo la finestra e lascio def-curr intatto.

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
// scelta OK sulla finestra: aggiorno le prefs
- (void)
userSelectUpdate:(id)sender
{

#define		MATRIX_GET_STATE( key, row, col )						\
	[defDispValues setObject: 								\
		([[colDspMatrix cellAtRow: row column:col] state ] ? lsPrefsYes : lsPrefsNo) 	\
		forKey:key]

	// devo recuperare i valori dalla finestra
	[defDispValues setObject:
		([expandBundleButton state] ? lsPrefsYes : lsPrefsNo) 
		forKey:keyExpandBundle];
	[defDispValues setObject:
		([showDotFilesButton state] ? lsPrefsYes : lsPrefsNo) 
		forKey:keyShowDotFiles];
	// recupero i valori secondo i controlli ed assegno le prefs
	MATRIX_GET_STATE( keyColModDate, 	0, 0 );
	MATRIX_GET_STATE( keyColFileSize, 	1, 0 );
	MATRIX_GET_STATE( keyColGroupName, 	2, 0 );
	MATRIX_GET_STATE( keyColOwnerName, 	3, 0 );
	MATRIX_GET_STATE( keyColPosixPerm, 	4, 0 );
	MATRIX_GET_STATE( keyColFileType, 	5, 0 );
	MATRIX_GET_STATE( keyColFullPath, 	0, 1 );
	MATRIX_GET_STATE( keyColOSType, 	1, 1 );
	MATRIX_GET_STATE( keyColCreator, 	2, 1 );
	MATRIX_GET_STATE( keyColFsFileNum, 	3, 1 );
	MATRIX_GET_STATE( keyColFsNum, 		4, 1 );		
	// recuperati i valori; li assegno ai correnti
	// salvo le preference su file
	[ UserPrefs savePrefsToDefault: defDispValues ];
	// e per finire nascondo la finestra
	[[self window] setIsVisible: FALSE ];
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
// scelta restore sulla finestra: rileggo le prefs
- (void) 
userSelectRestore:(id)sender
{
	[self setDefDispValues: [ UserPrefs getPrefs ] ];
	[self updatePrefWindow];
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
// scelta cancel sulla finestra: chiudo e faccio nulla
- (void) 
userSelectCancel:(id)sender
{
	// mi porto avanti e rimetto i defDisp a defCurr
	[self setDefDispValues: [ UserPrefs getPrefs ] ];
	[[self window] setIsVisible: FALSE ];
}

// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
- ( NSMutableDictionary*) defDispValues 		{ return defDispValues ; }
- (void) setDefDispValues: ( NSMutableDictionary*) new	OBJ_ACC_SET( defDispValues, new )

@end
