// - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - 
//  WaitPanCtrl.m
//  Created by djzero00 -- Copyright (c) 2002
//
// Finestra di lavori in corso

#import "WaitPanCtrl.h"

@implementation WaitPanCtrl

// --------------------------------------------------------------------- 
// imposto il testo presente all'interno della finestra
+ (void) setText: (NSString*) title
{
	// chiamo un metodo interno
	[ [ WaitPanCtrl sharedProgress] setMainText: title ];
}

// eseguo un passo di animazione della colonna del barbiere
+ (void) animate: (id) sender 
{
	// chiamo un metodo interno
	[ [ WaitPanCtrl sharedProgress] animation: sender ];
}

// mostro/nascondo la finestra 
+ (void) showHide: (BOOL) state
{
	// mostro/nascondo direttamente la fienstra
	[[[ WaitPanCtrl sharedProgress] window] setIsVisible: state ];
}

// --------------------------------------------------------------------- 
// istanza condivisa (e sua inizializzazione, se necessario) della finestra
+ (id) sharedProgress
{
	static WaitPanCtrl * _sharedProgress = nil ;

	if ( ! _sharedProgress )
	{
		_sharedProgress = [ [WaitPanCtrl alloc] init ];
	}
	
	return ( _sharedProgress );
}

// inizializzazione, carico il giusto nib
- (id )
init 
{
	self = [ self initWithWindowNibName: @"waitingPanel" ];
	return ( self );
}

// per impostare il testo della finestra
- (void ) 
setMainText: (NSString*) title
{
	// banale, imposto la stringa
	[ infoText setStringValue: title ] ;
	// forzo il rinfresco della finestra
	[ infoText displayIfNeeded ];
}

// per effettuare un passo di animazione
- (void) 
animation: (id) sender
{
	// passo di animazione
	[ progressBar animate: sender ] ;
	// forzo il rinfresco della finestra
	[ progressBar displayIfNeeded ];
}

@end
